#include "IRLibAll.h"

const int ENABLE = 4; // Festlegung Motorvariablen
const int IN1 = 9;
const int IN2 = 10;
const int IN3 = 5;
const int IN4 = 6;
int duration;
boolean crash = false; // Erkennung einer Kollision

// Infrarot
IRrecvPCI myReceiver(3);
IRdecode myDecoder;

// Ultraschall
int trigger = 11;
int echo = 12;
long dauer = 0;

int dist = 0;
int leftdist = 0;
int rightdist = 0;
int object = 300;             //distance at which the robot should look for another route                           


void setup ()
{
   Serial.begin(9600);
  // Motoren
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  pinMode(ENABLE, OUTPUT);
  //Ultraschall
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

  // Infrarot
  delay(2000); while (!Serial);
  myReceiver.enableIRIn(); // Start receiver
}

void loop()
{
  dist = analogRead(sensorpin);               //reads the sensor
 
  if(dist < object) {                         //if distance is less than 550
   forward();                                  //then move forward
  }
  if(dist >= object) {               //if distance is greater than or equal to 550
    findroute();
  }
  digitalWrite(trigger, LOW);
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
  dauer = pulseIn(echo, HIGH);
  entfernung = (dauer / 2) * 0.03432;
  if (entfernung >= 500 || entfernung <= 0)
  {
    Serial.println("Kein Messwert");
  }
  else
  {
    Serial.print(entfernung);
    Serial.println(" cm");
  }
  delay(500);

  // Infrarot
  if (myReceiver.getResults()) {
    myDecoder.decode();           //Decodierung
    myDecoder.dumpResults(true);
    myReceiver.enableIRIn();      //Receiver erneut starten
    Serial.println("detected");
}
 
void forward() {                            // use combination which works for you
  digitalWrite(ENABLE, HIGH);
  int pwm = 100;
  digitalWrite(IN1, pwm);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, pwm);
  digitalWrite(IN4, LOW);
  duration = 0;
  delay(100);
 }

void backward() {
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
  delay(500);
  halt();
  return;
}

void halt () {
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,LOW);
  delay(500);                          //wait after stopping
  return;
}
 
void turnleft () {
  digitalWrite(motor_pin1,HIGH);       //use the combination which works for you
  digitalWrite(motor_pin2,LOW);      //right motor rotates forward and left motor backward
  digitalWrite(motor_pin3,LOW);
  digitalWrite(motor_pin4,HIGH);
  delay(1000);                     // wait for the robot to make the turn
  halt();
  return;
}

void turnright () {
  digitalWrite(IN1,LOW);       //use the combination which works for you
  digitalWrite(IN2,HIGH);    //left motor rotates forward and right motor backward
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  delay(1000);                              // wait for the robot to make the turn
  halt();
  return;
}
